#include <windows.h>
#include <caml/alloc.h>
#include <caml/callback.h>
#include <caml/custom.h>
#include <caml/fail.h>
#include <caml/memory.h>
#include <caml/mlvalues.h>

CAMLprim value make_window(value unit)
{
    HWND hWnd;

    hWnd = CreateWindow("EDIT",
        "Generic Application",
        WS_OVERLAPPEDWINDOW|WS_HSCROLL|WS_VSCROLL,
        0,
        0,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        NULL,
        NULL,
        GetModuleHandle(NULL),
        NULL);

    ShowWindow(hWnd, SW_SHOWDEFAULT);

    return Val_unit;
}

CAMLprim value msg(value unit)
{
    MSG msg;

    if (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return Val_unit;
}
